Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package typechecker
  Definition Classes
    nsc
-  trait Macros extends MacroRuntimes with Traces with Helpers

  Code to deal with macros, namely with: * Compilation of macro definitions * Expansion of macro applications

  Code to deal with macros, namely with: * Compilation of macro definitions * Expansion of macro applications

  Say we have in a class C:

  def foo[T](xs: List[T]): T = macro fooBar

  Then fooBar needs to point to a static method of the following form:

  def fooBar[T: c.WeakTypeTag] // type tag annotation is optional (c: scala.reflect.macros.blackbox.Context) (xs: c.Expr[List[T]]) : c.Expr[T] = { ... }

  Then, if foo is called in qual.foo[Int](elems), where qual: D, the macro application is expanded to a reflective invocation of fooBar with parameters:

  (simpleMacroContext{ type PrefixType = D; val prefix = qual }) (Expr(elems)) (TypeTag(Int))

  Definition Classes
    typechecker
- DefMacroExpander
- Delayed
- Failure
- Fallback
- JavaReflectionResolvers
- MacroArgs
- MacroExpander
- MacroImplBinding
- MacroRuntimeResolver
- MacroStatus
- Skipped
- Success

c

scala.tools.nsc.typechecker.Macros

# DefMacroExpander 

###

#### class DefMacroExpander extends Analyzer.MacroExpander

Expands a term macro used in apply role as `M(2)(3)` in `val x = M(2)(3)`.

Source
  Macros.scala

Linear Supertypes
Analyzer.MacroExpander, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. DefMacroExpander
2. MacroExpander
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new DefMacroExpander(typer: Analyzer.Typer, expandee: Global.Tree, mode: Mode, outerPt: Global.Type)

   outerPt

     Expected type that comes from enclosing context (something that's traditionally called `pt`).

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Analyzer.DefMacroExpander to any2stringadd[Analyzer.DefMacroExpander] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Analyzer.DefMacroExpander, B)
   Implicit
     This member is added by an implicit conversion from Analyzer.DefMacroExpander to ArrowAssoc[Analyzer.DefMacroExpander] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def apply(desugared: Global.Tree): Global.Tree
   Definition Classes
     MacroExpander
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
9.  def ensuring(cond: (Analyzer.DefMacroExpander) ⇒ Boolean, msg: ⇒ Any): Analyzer.DefMacroExpander
   Implicit
     This member is added by an implicit conversion from Analyzer.DefMacroExpander to Ensuring[Analyzer.DefMacroExpander] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (Analyzer.DefMacroExpander) ⇒ Boolean): Analyzer.DefMacroExpander
    Implicit
      This member is added by an implicit conversion from Analyzer.DefMacroExpander to Ensuring[Analyzer.DefMacroExpander] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: ⇒ Any): Analyzer.DefMacroExpander
    Implicit
      This member is added by an implicit conversion from Analyzer.DefMacroExpander to Ensuring[Analyzer.DefMacroExpander] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): Analyzer.DefMacroExpander
    Implicit
      This member is added by an implicit conversion from Analyzer.DefMacroExpander to Ensuring[Analyzer.DefMacroExpander] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
15.  def expand(desugared: Global.Tree): Global.Tree
    Attributes
      protected
    Definition Classes
      MacroExpander
16.  val expandee: Global.Tree
    Definition Classes
      MacroExpander
17.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Analyzer.DefMacroExpander to StringFormat[Analyzer.DefMacroExpander] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
20.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
21.  lazy val innerPt: Global.Type
22.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
23.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
24.  final def notify(): Unit
    Definition Classes
      AnyRef
25.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
26.  def onDelayed(delayed: Global.Tree): Global.Tree
    Definition Classes
      DefMacroExpander → MacroExpander
27.  def onFailure(expanded: Global.Tree): Global.Tree
    Definition Classes
      MacroExpander
28.  def onFallback(fallback: Global.Tree): Global.Tree
    Definition Classes
      DefMacroExpander → MacroExpander
29.  def onSkipped(expanded: Global.Tree): Global.Tree
    Definition Classes
      MacroExpander
30.  def onSuccess(expanded0: Global.Tree): Global.Tree
    Definition Classes
      DefMacroExpander → MacroExpander
31.  def onSuppressed(expandee: Global.Tree): Global.Tree
    Definition Classes
      MacroExpander
32.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
33.  def toString(): String
    Definition Classes
      AnyRef → Any
34.  val typer: Analyzer.Typer
    Definition Classes
      MacroExpander
35.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
36.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
37.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
38.  def →[B](y: B): (Analyzer.DefMacroExpander, B)
    Implicit
      This member is added by an implicit conversion from Analyzer.DefMacroExpander to ArrowAssoc[Analyzer.DefMacroExpander] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Analyzer.MacroExpander

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Analyzer.DefMacroExpander to any2stringadd[Analyzer.DefMacroExpander]

### Inherited by implicit conversion StringFormat from Analyzer.DefMacroExpander to StringFormat[Analyzer.DefMacroExpander]

### Inherited by implicit conversion Ensuring from Analyzer.DefMacroExpander to Ensuring[Analyzer.DefMacroExpander]

### Inherited by implicit conversion ArrowAssoc from Analyzer.DefMacroExpander to ArrowAssoc[Analyzer.DefMacroExpander]

### Ungrouped